var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { getQueryString, fetchData, getError, isLangCodeSupported } from './utils';
import { RESULT_ERROR, LANGUAGE_NOT_SOPPORTED } from './errorCodes';
import { detect } from './detect';
export var translate = function (_a) {
    var text = _a.text, _b = _a.from, from = _b === void 0 ? '' : _b, _c = _a.to, to = _c === void 0 ? '' : _c, _d = _a.userLang, userLang = _d === void 0 ? '' : _d, _e = _a.autoDetect, autoDetect = _e === void 0 ? true : _e;
    return __awaiter(void 0, void 0, void 0, function () {
        var _f, _g, url, params, res, data, result, err_1;
        var _h, _j, _k, _l;
        return __generator(this, function (_m) {
            switch (_m.label) {
                case 0:
                    userLang = userLang || 'en';
                    _f = from;
                    if (_f) return [3 /*break*/, 4];
                    if (!(autoDetect && !to)) return [3 /*break*/, 2];
                    return [4 /*yield*/, detect(text)];
                case 1:
                    _g = _m.sent();
                    return [3 /*break*/, 3];
                case 2:
                    _g = 'auto';
                    _m.label = 3;
                case 3:
                    _f = (_g);
                    _m.label = 4;
                case 4:
                    from = _f;
                    to = to || (from === userLang ? 'en' : userLang);
                    if (!isLangCodeSupported(from) || !isLangCodeSupported(to)) {
                        throw getError(LANGUAGE_NOT_SOPPORTED);
                    }
                    url = "https://translate.googleapis.com/translate_a/single";
                    params = {
                        client: 'gtx',
                        sl: from,
                        tl: to,
                        hl: userLang || to,
                        dt: ['at', 'bd', 'ex', 'ld', 'md', 'qca', 'rw', 'rm', 'ss', 't'],
                        ie: 'UTF-8',
                        oe: 'UTF-8',
                        dj: 1,
                        q: encodeURIComponent(text)
                    };
                    url += getQueryString(params);
                    return [4 /*yield*/, fetchData(url)];
                case 5:
                    res = _m.sent();
                    _m.label = 6;
                case 6:
                    _m.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, res.json()];
                case 7:
                    data = _m.sent();
                    result = {
                        text: text,
                        from: data.src,
                        to: to,
                        result: (_h = data.sentences) === null || _h === void 0 ? void 0 : _h.reduce(function (t, v) { return (v.trans ? t.concat(v.trans) : t); }, []),
                        dict: (_j = data.dict) === null || _j === void 0 ? void 0 : _j.reduce(function (t, v) { return (t.concat(v.pos + ': ' + v.terms.join(', '))); }, []),
                        phonetic: (_l = (_k = data.sentences) === null || _k === void 0 ? void 0 : _k[1]) === null || _l === void 0 ? void 0 : _l.src_translit,
                        raw: data
                    };
                    return [2 /*return*/, result];
                case 8:
                    err_1 = _m.sent();
                    throw getError(RESULT_ERROR);
                case 9: return [2 /*return*/];
            }
        });
    });
};
